#! /usr/bin/lua

require 'Test.Assertion'

if not pcall(require, 'bc') then
    skip_all 'no bc'
end

plan(3)

local c = require 'CBOR'
local bc = require 'bc'
local TAG_BC = 42
bc.digits(65)
local number = bc.number or bc.new

function bc:tocbor (buffer)
    c.coders.tag(buffer, TAG_BC)
    c.coders.text_string(buffer, tostring(self))
end

c.coders.userdata = function (buffer, u)
    local mt = getmetatable(u)
    if mt and mt.tocbor then
        u:tocbor(buffer)
    else
        error("encode 'userdata' is unimplemented")
    end
end

c.register_tag(TAG_BC, function (data)
    return number(data)
end)

local orig = bc.sqrt(2)
local dest = c.decode(c.encode(orig))
equals( dest, orig, "bc" )
falsy( rawequal(orig, dest) )

error_matches( function ()
                c.encode( io.stdin )
        end,
        "encode 'userdata' is unimplemented" )

